'use strict';

var _chai = require('chai');

var _nock = require('nock');

var _nock2 = _interopRequireDefault(_nock);

var _dist = require('../dist');

var _dist2 = _interopRequireDefault(_dist);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint no-unused-expressions: 0 */
describe('actions', function () {

  it('cancel()', function (done) {
    (0, _nock2.default)(_utils.ROOT).get('/delay').delayConnection(200).reply(200, {
      status: 0
    });
    var req = (0, _dist2.default)({
      url: _utils.ROOT + '/delay',
      success: function success(res) {
        (0, _chai.expect)(res.status).to.be.equal(0);
      },
      error: function error(res) {
        (0, _chai.expect)(res.status).to.not.be.equal(0);
      }
    });
    req.send().then(done).catch(done);
    setTimeout(function () {
      req.cancel();
    }, 100);
    setTimeout(done, 300);
  });

  it('error()', function (done) {
    (0, _nock2.default)(_utils.ROOT).get('/delay').delayConnection(200).reply(200, {
      status: 0
    });
    var req = (0, _dist2.default)({
      url: _utils.ROOT + '/delay',
      success: function success(res) {
        (0, _chai.expect)(res.status).to.be.equal(0);
      },
      error: function error(res) {
        (0, _chai.expect)(res.status).to.be.equal(6);
        (0, _chai.expect)(res.customError).to.be.an('error');
        (0, _chai.expect)(res.customError.toString()).to.be.include('test');
      }
    });
    req.send().then(done).catch(done);
    setTimeout(function () {
      req.error(new Error('test'));
    }, 100);
    setTimeout(done, 300);
  });
});
//# sourceMappingURL=actions.spec.js.map